/*
  ணࠬ SQFRACT.
  稢 ࠪ⠫  ᭮ ⮢.
*/

#include <conio.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int X_max, Y_max, foregrcolor, backgrcolor, colorsum;
static int Xcur, Ycur;
float x_max, y_max, horfact, vertfact;

void boundaries_uc(void)
{

  int w, h;
  getaspectratio(&w, &h);
  y_max = x_max * (float)Y_max * h/((float)X_max * w);
  horfact = X_max/x_max;
  vertfact = Y_max/y_max;

}

void initgr(void)
{

  int grdriver = DETECT, grmode;

  detectgraph(&grdriver, &grmode);
  initgraph(&grdriver, &grmode, "");

  if ( graphresult() != grOk )
   printf("\n䨪  樠஢!\n");

  foregrcolor = getcolor();
  backgrcolor = getbkcolor();
  colorsum = foregrcolor + backgrcolor;

  X_max = getmaxx();
  Y_max = getmaxy();

  x_max = 10.0;

  boundaries_uc();

}

int IX(float x)
{

  return (int)(x * horfact + 0.5);

}

int IY(float y)
{

  return Y_max - (int)(y * vertfact + 0.5);

}

void move(float x, float y)
{

  Xcur = IX(x);
  Ycur = IY(y);
  moveto(Xcur, Ycur);

}

void draw(float x, float y)
{

  int X0 = Xcur, Y0 = Ycur;
  Xcur = IX(x);
  Ycur = IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur);

}

void endgr(void)
{

  getch();
  closegraph();

}

float f, fact;

void side(float xA, float yA, float xB, float yB, int n)
{

  float xP, yP, xQ, yQ, xR, yR, xS, yS, fdx, fdy;

  if ( n == 0 )
   draw(xB, yB);
  else {

		 fdx = fact * (xB - xA);
		 fdy = fact * (yB - yA);
		 xP = xA + fdx;
		 yP = yA + fdy;
		 xS = xB - fdx;
		 yS = yB - fdy;
		 xQ = xP + (yS - yP);
		 yQ = yP - (xS - xP);
		 xR = xQ + (xS - xP);
		 yR = yQ + (yS - yP);

		 draw(xP, yP);
		 side(xP, yP, xQ, yQ, n - 1);
		 side(xQ, yQ, xR, yR, n - 1);
		 side(xR, yR, xS, yS, n - 1);
		 draw(xB, yB);

	   }

}

void main()
{

  clrscr();
  int n, i;
  float p = 1, r, R, xC, yC;

  printf(" 㡨 ४ᨨ (ਬ, 5): ");
  scanf("%d", &n);

  printf("樥 㬥襭 (ਬ, 0.4): ");
  scanf("%f", &f);

  for(i = 0; i < n; i++)
   p *= f;

  fact = 0.5 * (1 - f);

  initgr();

  R = y_max/2.2 * (1 - f)/(1 - p);
  r = R/(1 + f);
  xC = x_max/2;
  yC = y_max/2;

  move(xC - r, yC - r);
  side(xC - r, yC - r, xC + r, yC - r, n);
  side(xC + r, yC - r, xC + r, yC + r, n);
  side(xC + r, yC + r, xC - r, yC + r, n);
  side(xC - r, yC + r, xC - r, yC - r, n);

  endgr();

}