/*
  ணࠬ SQUARES.
  ணࠬ  ४ᨢ 㭪樥 祭 ⮢.
*/

#define EAST 1
#define NORTH 2
#define WEST 3
#define SOUTH 4

#include <conio.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int X_max, Y_max, foregrcolor, backgrcolor, colorsum;
static int Xcur, Ycur;
float x_max, y_max, horfact, vertfact;

void boundaries_uc(void)
{

  int w, h;
  getaspectratio(&w, &h);
  y_max = x_max * (float)Y_max * h/((float)X_max * w);
  horfact = X_max/x_max;
  vertfact = Y_max/y_max;

}

void initgr(void)
{

  int grdriver = DETECT, grmode;

  detectgraph(&grdriver, &grmode);
  initgraph(&grdriver, &grmode, "");

  if ( graphresult() != grOk )
   printf("\n䨪  樠஢!\n");

  foregrcolor = getcolor();
  backgrcolor = getbkcolor();
  colorsum = foregrcolor + backgrcolor;

  X_max = getmaxx();
  Y_max = getmaxy();

  x_max = 10.0;

  boundaries_uc();

}

int IX(float x)
{

  return (int)(x * horfact + 0.5);

}

int IY(float y)
{

  return Y_max - (int)(y * vertfact + 0.5);

}

void move(float x, float y)
{

  Xcur = IX(x);
  Ycur = IY(y);
  moveto(Xcur, Ycur);

}

void draw(float x, float y)
{

  int X0 = Xcur, Y0 = Ycur;
  Xcur = IX(x);
  Ycur = IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur);

}

void endgr(void)
{

  getch();
  closegraph();

}

float f, c;
int filling, all4;

void square1(float x, float y, float r)
{

  float xA, yA, xB, yB, xC, yC, xD, yD;
  int points[10];

  xA = x - r;
  yA = y - r;
  xB = x + r;
  yB = y - r;
  xC = x + r;
  yC = y + r;
  xD = x - r;
  yD = y + r;

  if ( filling )
   {

	 points[0] = IX(xA);
	 points[1] = IY(yA);
	 points[2] = IX(xB);
	 points[3] = IY(yB);
	 points[4] = IX(xC);
	 points[5] = IY(yC);
	 points[6] = IX(xD);
	 points[7] = IY(yD);
	 points[8] = points[0];
	 points[9] = points[1];
	 fillpoly(5, points);

   }
  else {

		 move(xA, yA);
		 draw(xB, yB);
		 draw(xC, yC);
		 draw(xD, yD);
		 draw(xA, yA);

	   }

}

void squares(float x, float y, float r, int n, int dir)
{

  int n1 = n - 1;
  float fr = f * r, cr = c * r;

  if ( n > 0 )
   {

	  if ( dir != WEST || all4 )
		squares(x + cr, y, fr, n1, EAST);
	  if ( dir != SOUTH || all4 )
	   squares(x, y + cr, fr, n1, NORTH);
	  if ( dir != EAST || all4 )
	   squares(x - cr, y, fr, n1, WEST);
	  if ( dir != NORTH || all4 )
	   squares(x, y - cr, fr, n1, SOUTH);

	  square1(x, y, r);

   }

}

void main(void)
{

  clrscr();
  int n, i, m;
  float p = 1, r, R;

  printf(" 㡨 ४ᨨ (ਬ, 5): ");
  scanf("%d", &n);

  printf("樥 㬥襭 (ਬ, 0.5): ");
  scanf("%f", &f);

  printf("   ࠧࠬ ஭ 2r 業 ⥫ ⮢ \nᯮ  ﭨ cr  窨 P - 業 室 .\n 祭 c (ਬ, 2.0): ");
  scanf("%f", &c);

  for (i = 0; i < n; i++)
   p *= f;

  printf(" ᫮ 1, ᫨    襭,  0  ⨢\n砥: ");
  scanf("%d", &filling);

  do
   {

	 printf(" 3  4 ⥫   ? ");
	 scanf("%d", &m);

   } while ( m < 3 || m > 4);

  all4 = (m == 4);

  initgr();

  setfillstyle(CLOSE_DOT_FILL, foregrcolor);

  R = y_max/2.2 * (1 - f)/(1 - p);
  r = R/c;
  squares(x_max/2, y_max/2, r, n, 0);

  endgr();

}