/*
  ணࠬ TRIANGLES.
   אַ㣮 㣮쭨 ࠧ ࠧ஢.
*/

#include <conio.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int X_max, Y_max, foregrcolor, backgrcolor, colorsum;
static int Xcur, Ycur;
float x_max, y_max, horfact, vertfact;

void boundaries_uc(void)
{

  int w, h;
  getaspectratio(&w, &h);
  y_max = x_max * (float)Y_max * h/((float)X_max * w);
  horfact = X_max/x_max;
  vertfact = Y_max/y_max;

}

void initgr(void)
{

  int grdriver = DETECT, grmode;

  detectgraph(&grdriver, &grmode);
  initgraph(&grdriver, &grmode, "");

  if ( graphresult() != grOk )
   printf("\n䨪  樠஢!\n");

  foregrcolor = getcolor();
  backgrcolor = getbkcolor();
  colorsum = foregrcolor + backgrcolor;

  X_max = getmaxx();
  Y_max = getmaxy();

  x_max = 10.0;

  boundaries_uc();

}

int IX(float x)
{

  return (int)(x * horfact + 0.5);

}

int IY(float y)
{

  return Y_max - (int)(y * vertfact + 0.5);

}

void move(float x, float y)
{

  Xcur = IX(x);
  Ycur = IY(y);
  moveto(Xcur, Ycur);

}

void draw(float x, float y)
{

  int X0 = Xcur, Y0 = Ycur;
  Xcur = IX(x);
  Ycur = IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur);

}

void endgr(void)
{

  getch();
  closegraph();

}

void tria(float xA, float yA, float xB, float yB, float xC, float yC, int n)
{ 
  float xP, yP, xQ, yQ, xR, yR;
  if ( n > 0 )
   {

	 xP = (xB + xC)/2;
	 yP = (yB + yC)/2;
	 xQ = (xC + xA)/2;
	 yQ = (yC + yA)/2;
	 xR = (xA + xB)/2;
	 yR = (yA + yB)/2;

	 move(xP, yP);
	 draw(xQ, yQ);
	 draw(xR, yR);
	 draw(xP, yP);

	 tria(xA, yA, xR, yR, xQ, yQ, n - 1);
	 tria(xB, yB, xP, yP, xR, yR, n - 1);
	 tria(xC, yC, xQ, yQ, xP, yP, n - 1);

   }

}

void main()
{

  clrscr();
  int n;
  float xA, yA, xB, yB, xC, yC;

  printf(" 㡨 ४ᨨ (ਬ, 7): ");
  scanf("%d", &n);
    
  initgr();

  xA = 0.0;
  yA = 0.0;
  xB = x_max;
  yB = 0.0;
  xC = 0.0;
  yC = y_max;

  move(xA, yA);
  draw(xB, yB);
  draw(xC, yC);
  draw(xA, yA);

  tria(xA, yA, xB, yB, xC, yC, n);

  endgr();

}

