{
  ணࠬ SQFRACT.
  稢 ࠪ⠫  ᭮ ⮢.
}

uses crt, graph;

var
 X_max, Y_max, foregrcolor, backgrcolor, colorsum : integer;
 Xcur, Ycur : integer;
 x_max1, y_max1, horfact, vertfact : real;
 f, fact : real;
 n, i : integer;
 p, R, r1, xC, yC : real;

procedure boundaries_uc;
var w, h : word;
begin
  getaspectratio(w, h);
  y_max1 := x_max1 * Y_max * h/(X_max * w);
  horfact := X_max/x_max1;
  vertfact := Y_max/y_max1
end;

procedure initgr;
var grdriver, grmode : integer;
begin
  grdriver := DETECT;

  detectgraph(grdriver, grmode);
  initgraph(grdriver, grmode, '');

  if ( graphresult <> grOk ) then begin
   writeln;
   writeln('䨪  樠஢!');
   halt
  end;

  foregrcolor := getcolor;
  backgrcolor := getbkcolor;
  colorsum := foregrcolor + backgrcolor;

  X_max := getmaxx;
  Y_max := getmaxy;

  x_max1 := 10;

  boundaries_uc

end;

function IX(x : real) : integer;
begin
 IX := trunc(x * horfact + 0.5)
end;

function IY(y : real) : integer;
begin
 IY := Y_max - trunc(y * vertfact + 0.5)
end;

procedure move(x, y : real);
begin
  Xcur := IX(x);
  Ycur := IY(y);
  moveto(Xcur, Ycur)

end;

procedure draw(x, y : real);
var X0, Y0 : integer;
begin
  X0 := Xcur;
  Y0 := Ycur;
  Xcur := IX(x);
  Ycur := IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur)
end;

procedure endgr;
begin
  readkey;
  closegraph
end;

procedure side(xA, yA, xB, yB : real; n : integer);
var xP, yP, xQ, yQ, xR, yR, xS, yS, fdx, fdy : real;
begin
  if ( n = 0 ) then
   draw(xB, yB)
  else begin
   fdx := fact * (xB - xA);
   fdy := fact * (yB - yA);
   xP := xA + fdx;
   yP := yA + fdy;
   xS := xB - fdx;
   yS := yB - fdy;
   xQ := xP + (yS - yP);
   yQ := yP - (xS - xP);
   xR := xQ + (xS - xP);
   yR := yQ + (yS - yP);

   draw(xP, yP);
   side(xP, yP, xQ, yQ, n - 1);
   side(xQ, yQ, xR, yR, n - 1);
   side(xR, yR, xS, yS, n - 1);
   draw(xB, yB)
  end
end;

begin
 clrscr;
 p := 1;
 write(' 㡨 ४ᨨ (ਬ, 5): ');
 readln(n);
 write('樥 㬥襭 (ਬ, 0.4): ');
 readln(f);

 for i := 0 to n - 1 do
  p := p * f;

 fact := 0.5 * (1 - f);

 initgr;

 R := y_max1/2.2 * (1 - f)/(1 - p);
 r1 := R/(1 + f);
 xC := x_max1/2;
 yC := y_max1/2;

 move(xC - r1, yC - r1);
 side(xC - r1, yC - r1, xC + r1, yC - r1, n);
 side(xC + r1, yC - r1, xC + r1, yC + r1, n);
 side(xC + r1, yC + r1, xC - r1, yC + r1, n);
 side(xC - r1, yC + r1, xC - r1, yC - r1, n);

 endgr
end.

