{
  ணࠬ TTREE.
  ନ஢ ॢ  㪢 T.
}

uses crt, graph;

var
 X_max, Y_max, foregrcolor, backgrcolor, colorsum : integer;
 Xcur, Ycur : integer;
 x_max1, y_max1, horfact, vertfact : real;
 fx, fy, threshold : real;
 a, b, powerfx, powerfy : real;
 n, i : integer;

procedure boundaries_uc;
var w, h : word;
begin
  getaspectratio(w, h);
  y_max1 := x_max1 * Y_max * h/(X_max * w);
  horfact := X_max/x_max1;
  vertfact := Y_max/y_max1
end;

procedure initgr;
var grdriver, grmode : integer;
begin
  grdriver := DETECT;

  detectgraph(grdriver, grmode);
  initgraph(grdriver, grmode, '');

  if ( graphresult <> grOk ) then begin
   writeln;
   writeln('䨪  樠஢!');
   halt
  end;

  foregrcolor := getcolor;
  backgrcolor := getbkcolor;
  colorsum := foregrcolor + backgrcolor;

  X_max := getmaxx;
  Y_max := getmaxy;

  x_max1 := 10;

  boundaries_uc

end;

function IX(x : real) : integer;
begin
 IX := trunc(x * horfact + 0.5)
end;

function IY(y : real) : integer;
begin
 IY := Y_max - trunc(y * vertfact + 0.5)
end;

procedure move(x, y : real);
begin
  Xcur := IX(x);
  Ycur := IY(y);
  moveto(Xcur, Ycur)

end;

procedure draw(x, y : real);
var X0, Y0 : integer;
begin
  X0 := Xcur;
  Y0 := Ycur;
  Xcur := IX(x);
  Ycur := IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur)
end;

procedure endgr;
begin
  readkey;
  closegraph
end;

procedure T(xA, yA, a, b, n : real);
var xB, yB, xC, yC, xD, yD, a1, b1 : real;
begin

{
  A 砥   㪢 T. 楢 窨
  ਧ⠫쭮 (孥) १ 祭
  㪢 C (᫥)  D (ࠢ), । 窠 - D.
}

  if ( n > 0 ) then begin
   xB := xA;
   yB := yA + a;
   xC := xB - b;
   yC := yB;
   xD := xB + b;
   yD := yB;
   a1 := fy * a;

   if ( a1 < 0 ) then
    a1 := -a1;

   b1 := fx * b;
   move(xA, yA);
   draw(xB, yB);
   draw(xC, yC);

   if ( random(100) >= threshold ) then
    a1 := -a1;

   T(xC, yC, a1, b1, n - 1);

   move(xB, yB);
   draw(xD, yD);

   if ( random(100) >= threshold ) then
    a1 := -a1;

   T(xD, yD, a1, b1, n - 1)
  end
end;

begin
 clrscr;
 randomize;

 writeln(' 祭 樥⮢:');
 writeln('fx fy 㡨 ४ᨨ % 㬥襭  (ਬ, 0.5 0.4 7 70):');
 readln(fx, fy, n, threshold);

 initgr;
 powerfx := fx;
 powerfy := fy;

 for i := 2 to n do begin
  powerfx := powerfx * fx;
  powerfy := powerfy * fy
 end;

 b := 0.5 * x_max1 * (1 - fx)/(1 - powerfx);
 a := y_max1 * (1 - fy)/(1 - powerfy);
 T(x_max1/2, y_max1/2 - a, a, b, n);

 endgr
end.