/*
  ணࠬ FRCURVE.
   ணࠬ ந    ਧ⠫쭮
  १,   ஭ ࠢ쭮 㣮쭨
  ࠪ⠫쭮 ਢ    ମ
*/

#include <conio.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int X_max, Y_max, foregrcolor, backgrcolor, colorsum;
static int Xcur, Ycur;
float x_max, y_max, horfact, vertfact;

void boundaries_uc(void)
{

  int w, h;
  getaspectratio(&w, &h);
  y_max = x_max * (float)Y_max * h/((float)X_max * w);
  horfact = X_max/x_max;
  vertfact = Y_max/y_max;

}

void initgr(void)
{

  int grdriver = DETECT, grmode;

  detectgraph(&grdriver, &grmode);
  initgraph(&grdriver, &grmode, "");

  if ( graphresult() != grOk )
   printf("\n䨪  樠஢!\n");

  foregrcolor = getcolor();
  backgrcolor = getbkcolor();
  colorsum = foregrcolor + backgrcolor;

  X_max = getmaxx();
  Y_max = getmaxy();

  x_max = 10.0;

  boundaries_uc();

}

int IX(float x)
{

  return (int)(x * horfact + 0.5);

}

int IY(float y)
{

  return Y_max - (int)(y * vertfact + 0.5);

}

void move(float x, float y)
{

  Xcur = IX(x);
  Ycur = IY(y);
  moveto(Xcur, Ycur);

}

void draw(float x, float y)
{

  int X0 = Xcur, Y0 = Ycur;
  Xcur = IX(x);
  Ycur = IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur);

}

void endgr(void)
{

  getch();
  closegraph();

}

int nmodel = 0;
float xx[30], yy[30];

void side(float xA, float yA, float xB, float yB, int n)
{
  int i;
  float x, y, x1, y1, dx = xB - xA, dy = yB - yA;

  if ( n == 0 )
   {

	 move(xA, yA);
	 draw(xB, yB);

   }
  else {

		 x1 = xA;
		 y1 = yA;
		 for (i = 1; i <= nmodel; i++)
		  {

			x = x1;
			y = y1;
			x1 = xA + dx * xx[i] - dy * yy[i];
			y1 = yA + dy * xx[i] + dx * yy[i];
			side(x, y, x1, y1, n - 1);

		  }

	   }

}

void main(void)
{

  clrscr();
  int n, k, i;
  float pi, theta, r, x, y, x1, y1, xC, yC, sizefactor, xmargin, phi;

  printf("\n 1, ᫨  ⢥   ਧ⠫ १.\n    ࠢ쭮 k-㣮쭨  ᫮ k (ਬ, 4): ");
  scanf("%d", &k);
  printf("\n㡨 ४ᨨ (ਬ, 4): ");
  scanf("%d", &n);
  printf("\n쪮  祪  (0, 0)  (1, 0)? (ਬ, 3): ");
  scanf("%d", &nmodel);

  /*
	 ࠬ nmodel । ⢮ १ אַ
	  楢묨 窠 (0, 0)  (1, 0)  १.
  */
  nmodel++;

  printf("\n  न (x, y)  祪, ᪫ 窨 (0, 0)  (1, 0).\nਬ,\n0.45 0\n0.5 0.45\n0.55 0\n\n");

  for (i = 1; i < nmodel; i++)
   scanf("%f %f", xx + i, yy + i);

  printf("\n樥 ࠧ (1.0 - ଠ ࠧ): ");
  scanf("%f", &sizefactor);

  /*
	 ⠫  ᨢ 樠 ﬨ
  */
  xx[nmodel] = 1.0;

  initgr();

  if ( k < 3 )
   {

	 xmargin = 0.5 * (x_max - sizefactor * (x_max - 1));
	 side(xmargin, 0.5 * y_max, x_max - xmargin, 0.5 * y_max, n);

   }
  else {

		 xC = x_max/2;
		 yC = y_max/2;
		 r = 0.9 * yC * sizefactor;
		 pi = 4 * atan(1.0);
		 theta = 2 * pi/k;
		 phi = -0.5 * theta;
		 x1 = xC + r * cos(phi);
		 y1 = yC + r * sin(phi);

		 for (i = 0; i < k; i++)
		  {

			x = x1;
			y = y1;
			phi += theta;
			x1 = xC + r * cos(phi);
			y1 = yC + r * sin(phi);
			side(x, y, x1, y1, n);

		  }

	   }
  endgr();

}