{
  ணࠬ SQUARES.
  ணࠬ  ४ᨢ 㭪樥 祭 ⮢.
}

uses crt, graph;

const
 EAST = 1;
 NORTH = 2;
 WEST = 3;
 SOUTH = 4;

var
 X_max, Y_max, foregrcolor, backgrcolor, colorsum : integer;
 Xcur, Ycur : integer;
 x_max1, y_max1, horfact, vertfact : real;
 f, c : real;
 filling : integer;
 all4 : boolean;
 n, i, m : integer;
 p, R, r1 : real;

procedure boundaries_uc;
var w, h : word;
begin
  getaspectratio(w, h);
  y_max1 := x_max1 * Y_max * h/(X_max * w);
  horfact := X_max/x_max1;
  vertfact := Y_max/y_max1
end;

procedure initgr;
var grdriver, grmode : integer;
begin
  grdriver := DETECT;

  detectgraph(grdriver, grmode);
  initgraph(grdriver, grmode, '');

  if ( graphresult <> grOk ) then begin
   writeln;
   writeln('䨪  樠஢!');
   halt
  end;

  foregrcolor := getcolor;
  backgrcolor := getbkcolor;
  colorsum := foregrcolor + backgrcolor;

  X_max := getmaxx;
  Y_max := getmaxy;

  x_max1 := 10;

  boundaries_uc

end;

function IX(x : real) : integer;
begin
 IX := trunc(x * horfact + 0.5)
end;

function IY(y : real) : integer;
begin
 IY := Y_max - trunc(y * vertfact + 0.5)
end;

procedure move(x, y : real);
begin
  Xcur := IX(x);
  Ycur := IY(y);
  moveto(Xcur, Ycur)

end;

procedure draw(x, y : real);
var X0, Y0 : integer;
begin
  X0 := Xcur;
  Y0 := Ycur;
  Xcur := IX(x);
  Ycur := IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur)
end;

procedure endgr;
begin
  readkey;
  closegraph
end;

procedure square1(x, y, r : real);
var xA, yA, xB, yB, xC, yC, xD, yD : real;
    points : array[0 .. 9] of integer;
begin
  xA := x - r;
  yA := y - r;
  xB := x + r;
  yB := y - r;
  xC := x + r;
  yC := y + r;
  xD := x - r;
  yD := y + r;

  if ( filling = 1 ) then begin
   points[0] := IX(xA);
   points[1] := IY(yA);
   points[2] := IX(xB);
   points[3] := IY(yB);
   points[4] := IX(xC);
   points[5] := IY(yC);
   points[6] := IX(xD);
   points[7] := IY(yD);
   points[8] := points[0];
   points[9] := points[1];
   fillpoly(5, points)
  end
  else begin
   move(xA, yA);
   draw(xB, yB);
   draw(xC, yC);
   draw(xD, yD);
   draw(xA, yA)
  end
end;

procedure squares(x, y, r : real; n, dir : integer);
var n1 : integer;
    fr, cr : real;
begin
 n1 := n - 1;
 fr := f * r;
 cr := c * r;

 if ( n > 0 ) then begin
  if ( dir <> WEST ) or ( dir <> integer(all4) ) then
   squares(x + cr, y, fr, n1, EAST);
  if ( dir <> SOUTH ) or ( dir <> integer(all4) ) then
   squares(x, y + cr, fr, n1, NORTH);
  if ( dir <> EAST ) or ( dir <> integer(all4) ) then
   squares(x - cr, y, fr, n1, WEST);
  if ( dir <> NORTH ) or ( dir <> integer(all4) ) then
   squares(x, y - cr, fr, n1, SOUTH);

  square1(x, y, r)
 end
end;

begin
 clrscr;
 p := 1;

 write(' 㡨 ४ᨨ (ਬ, 5): ');
 readln(n);

 write('樥 㬥襭 (ਬ, 0.5): ');
 readln(f);

 writeln('   ࠧࠬ ஭ 2r 業 ⥫ ⮢ ');
 writeln('ᯮ  ﭨ cr  窨 P - 業 室 .');
 write(' 祭 c (ਬ, 2.0): ');
 readln(c);

 for i := 0 to n - 1 do
  p := p * f;

 writeln(' ᫮ 1, ᫨    襭,  0  ⨢');
 write('砥: ');
 readln(filling);

 repeat
  write(' 3  4 ⥫   ? ');
  readln(m)
 until ( m >= 3 ) and ( m <= 4 );

  all4 := (m = 4);

  initgr;

  setfillstyle(CLOSEDOTFILL, foregrcolor);

  R := y_max1/2.2 * (1 - f)/(1 - p);
  r1 := R/c;
  squares(x_max1/2, y_max1/2, r1, n, 0);

  endgr

end.