{
  ணࠬ TRIANGLES.
   אַ㣮 㣮쭨 ࠧ ࠧ஢.
}

uses crt, graph;

var
 X_max, Y_max, foregrcolor, backgrcolor, colorsum : integer;
 Xcur, Ycur : integer;
 x_max1, y_max1, horfact, vertfact : real;
 n : integer;
 xA, yA, xB, yB, xC, yC : real;


procedure boundaries_uc;
var w, h : word;
begin
  getaspectratio(w, h);
  y_max1 := x_max1 * Y_max * h/(X_max * w);
  horfact := X_max/x_max1;
  vertfact := Y_max/y_max1
end;

procedure initgr;
var grdriver, grmode : integer;
begin
  grdriver := DETECT;

  detectgraph(grdriver, grmode);
  initgraph(grdriver, grmode, '');

  if ( graphresult <> grOk ) then begin
   writeln;
   writeln('䨪  樠஢!');
   halt
  end;

  foregrcolor := getcolor;
  backgrcolor := getbkcolor;
  colorsum := foregrcolor + backgrcolor;

  X_max := getmaxx;
  Y_max := getmaxy;

  x_max1 := 10;

  boundaries_uc

end;

function IX(x : real) : integer;
begin
 IX := trunc(x * horfact + 0.5)
end;

function IY(y : real) : integer;
begin
 IY := Y_max - trunc(y * vertfact + 0.5)
end;

procedure move(x, y : real);
begin
  Xcur := IX(x);
  Ycur := IY(y);
  moveto(Xcur, Ycur)

end;

procedure draw(x, y : real);
var X0, Y0 : integer;
begin
  X0 := Xcur;
  Y0 := Ycur;
  Xcur := IX(x);
  Ycur := IY(y);
  line(X0, Y0, Xcur, Ycur);
  moveto(Xcur, Ycur)
end;

procedure endgr;
begin
  readkey;
  closegraph
end;

procedure tria(xA, yA, xB, yB, xC, yC : real; n : integer);
var xP, yP, xQ, yQ, xR, yR : real;
begin
  if ( n > 0 ) then begin
   xP := (xB + xC)/2;
   yP := (yB + yC)/2;
   xQ := (xC + xA)/2;
   yQ := (yC + yA)/2;
   xR := (xA + xB)/2;
   yR := (yA + yB)/2;

   move(xP, yP);
   draw(xQ, yQ);
   draw(xR, yR);
   draw(xP, yP);

   tria(xA, yA, xR, yR, xQ, yQ, n - 1);
   tria(xB, yB, xP, yP, xR, yR, n - 1);
   tria(xC, yC, xQ, yQ, xP, yP, n - 1)
  end
end;

begin
  clrscr;

  write(' 㡨 ४ᨨ (ਬ, 7): ');
  readln(n);

  initgr;

  xA := 0.0;
  yA := 0.0;
  xB := x_max1;
  yB := 0.0;
  xC := 0.0;
  yC := y_max1;

  move(xA, yA);
  draw(xB, yB);
  draw(xC, yC);
  draw(xA, yA);

  tria(xA, yA, xB, yB, xC, yC, n);

  endgr

end.